#include <TimeLib.h>
#define TIME_HEADER  "T"
#define TIME_REQUEST  7
//#define MEZ 7200 //Sommer
#define MEZ 3600 //Winter

void setup()  {
  Serial.begin(9600);
  pinMode(13, OUTPUT);
  setSyncProvider(requestSync);
  Serial.println("Warte auf Unix-Zeitangabe - beginnt mit T");
}

void loop(){    
  if (Serial.available()) {
    processSyncMessage();
  }
  if (timeStatus()!= timeNotSet) {
    digitalClockDisplay();  
  }
  if (timeStatus() == timeSet) {
    digitalWrite(13, HIGH); 
  } else {
    digitalWrite(13, LOW);
  }
  delay(1000);
}

void digitalClockDisplay(){
  printDigits(hour());
  Serial.print(":");
  printDigits(minute());
  Serial.print(":");
  printDigits(second());
  Serial.print(" ");
  Serial.print(dayShortStr(weekday()));
  Serial.print(" ");
  Serial.print(day());
  Serial.print(".");
  Serial.print(month());
  Serial.print(".");
  Serial.print(year()); 
  Serial.println(); 
}

void printDigits(int digits){
  if(digits < 10)
    Serial.print('0');
  Serial.print(digits);
}

void processSyncMessage(){
  unsigned long pctime;
  const unsigned long DEFAULT_TIME = 1357041600;
  if(Serial.find(TIME_HEADER)) {
     pctime = Serial.parseInt();
     if( pctime >= DEFAULT_TIME) { 
       pctime += MEZ;
       setTime(pctime);
     }
  }
}

time_t requestSync(){
  Serial.write(TIME_REQUEST);  
  return 0; 
}
