#include <TimeLib.h>  
#include <LiquidCrystal.h>
#define TIME_HEADER  'T' 
#define TIME_REQUEST  7 
//#define MEZ 7200 //Sommer
#define MEZ 3600 //Winter
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

void setup(){
  lcd.begin(16,2); 
  lcd.clear();
  Serial.begin(9600);
  pinMode(13, OUTPUT);
  setSyncProvider(requestSync);
  Serial.println("Warte auf Unix-Zeitangabe - beginnt mit T");
}

void loop(){    
  if (Serial.available()) {
    processSyncMessage();
  }
  if (timeStatus()!= timeNotSet) {
    digitalClockDisplay();  
  }
  if (timeStatus() == timeSet) {
    digitalWrite(13, HIGH); 
  } else {
    digitalWrite(13, LOW);
  }
  delay(1000);
}

void digitalClockDisplay(){
  lcd.setCursor(4,0);
  printDigits(hour());
  lcd.print(":");
  printDigits(minute());
  lcd.print(":");
  printDigits(second());
  lcd.setCursor(0,1);
  lcd.print(dayShortStr(weekday()));
  lcd.print(" ");
  lcd.print(day());
  lcd.print(".");
  lcd.print(month());
    lcd.print(".");
  lcd.print(year()); 
}

void printDigits(int digits){
  if(digits < 10){
    lcd.print('0');
  }
  lcd.print(digits);
}

void processSyncMessage(){
  unsigned long pctime;
  const unsigned long DEFAULT_TIME = 1357041600;
  if(Serial.find(TIME_HEADER)) {
     pctime = Serial.parseInt();
     if( pctime >= DEFAULT_TIME) { 
       pctime += MEZ;
       setTime(pctime);
     }
  }
}

time_t requestSync(){
  Serial.write(TIME_REQUEST);  
  return 0; 
}
